-- Tables --

function playervar(d,val)
	local array = {}
	for i = 1, d do
		array[i] = val
	end
	return array
end

rocket = playervar(32,{stat=false,id=0,x=0,y=0,a=0,l=0,img=-1,mark=-1})

-- Config --

rimg = "gfx/rocket.png"
rdamage = 220
rsensitivity = 5
rspeed = 8
rscandistance = 320
rliving = 50
rcost = 10000

-- Funcs and Hooks --

addhook("serveraction","rserveract")
function rserveract(id,act)
	local t=player(id,"team")
	if t==1 then 
		t=2 
	else 
		t=1 
	end
	for _, en in ipairs(player(0,"team"..t.."living")) do
		if act==1 then
			local x, y, x2, y2 = player(id,"x"), player(id,"y"), player(en,"x"), player(en,"y")
			local distance = math.sqrt((x-x2)^2 + (y-y2)^2)
			if not rocket[id].stat and distance<=rscandistance and player(id,"money")>=10000 then
				rocket[id].stat = true
				rocket[id].img = image(rimg,player(id,"x"),player(id,"y"),3)
				rocket[id].x = player(id,"x")
				rocket[id].y = player(id,"y")
				rocket[id].id = en
				rocket[id].a = player(id,"rot")
				rocket[id].l = rliving
				rocket[id].mark = image("gfx/player/marker.bmp<b>",0,0,132+en)
				imagescale(rocket[id].mark,3,3)
				imagecolor(rocket[id].mark,255,0,0)
				parse("setmoney "..id.." "..player(id,"money")-10000)
				parse('sv_sound2 '..id..' "weapons/rocket.ogg"')
				parse('effect "smoke" '..x-math.sin(math.rad(player(id,"rot")))*(32)..' '..y+math.cos(math.rad(player(id,"rot")))*(32)..' 120 32')
				local disappear= function()
					freeimage(rocket[id].mark)
				end
				freetimer("dissapear")
				timer(1000,"dissapear")
				parse('hudtxt2 '..id..' 48 "\169255000000Missile destination: '..player(rocket[id].id,'name')..'" 320 210 1')
				parse('hudtxtalphafade '..id..' 48 2000 0')
				break
			end
		end
	end
end

addhook("always","ralways")
function ralways()
	for id = 1, 32 do
		if rocket[id].stat then
			local x, y = rocket[id].x, rocket[id].y
			local xen, yen = player(rocket[id].id,"x"), player(rocket[id].id,"y")
			local an = -math.deg (math.atan2( x - xen, y - yen ) )
			local d = math.sqrt((x-xen)^2 + (y-yen)^2)
			if rocket[id].a<an then
				rocket[id].a = rocket[id].a+rsensitivity
			elseif rocket[id].a>an then
				rocket[id].a = rocket[id].a-rsensitivity
			else
				rocket[id].a = an
			end
			local dx, dy = x-math.sin(math.rad(rocket[id].a-180))*rspeed, y+math.cos(math.rad(rocket[id].a-180))*rspeed
			rocket[id].x = dx
			rocket[id].y = dy
			local random = math.random(1,10)
			if random >=6 then
				parse('effect "smoke" '..dx..' '..dy..' 1 1')
			elseif random<=2 then
				parse('effect "fire" '..dx..' '..dy..' 1 1')
			end
			imagepos(rocket[id].img,rocket[id].x,rocket[id].y,rocket[id].a)
			rocket[id].l = rocket[id].l - 1
			if rocket[id].l<=0 then
				parse("explosion "..rocket[id].x.." "..rocket[id].y.." 100 "..rdamage.." "..id)
				freeimage(rocket[id].img)
				freeimage(rocket[id].mark)
				rocket[id].stat=false
				freetimer()
			end
			if d <15 then
				parse("explosion "..rocket[id].x.." "..rocket[id].y.." 100 "..rdamage.." "..id)
				freeimage(rocket[id].img)
				freeimage(rocket[id].mark)
				rocket[id].stat=false
				freetimer()
			end
			if tile(math.floor(dx/32),math.floor(dy/32),"wall") then
				parse("explosion "..rocket[id].x.." "..rocket[id].y.." 100 "..rdamage.." "..id)
				freeimage(rocket[id].img)
				freeimage(rocket[id].mark)
				rocket[id].stat=false
				freetimer()
			end
			break
		end
	end
end